proc start_running {} {
  global clock_running
  if { $clock_running == 0 } {
    set clock_running 1
    run_clock
  }
}  

proc run_clock {} {

 global clock_running clk_count 

# counts every second - 10 * 100ms

 if { $clk_count % 10 == 5 } {
	run_command clock1
 }
 if { $clk_count % 10 == 0} {
	run_command clock0
 }

 run_command run100

 incr clk_count

#update the seven segment displays

 if { $clock_running == 1 } {
	 paint_displays

	after 20 run_clock
 }
# changed to 50 for demo
}

proc paint_displays {} {

global twodisplays

    update_display .topwindow.display_r [run_command examine_display_r]

# the left display is updated only if variable twodisplays is set to 1

if { $twodisplays == 1 } {
  update_display .topwindow.display_l [run_command examine_display_l]
}

}


proc CreateWindow. {args} {


  # Window manager configurations
  destroy     .topwindow
  toplevel    .topwindow -width 350 -height 350

  global twodisplays

  wm title .topwindow "Altera UP-2 Simulator"
  wm protocol .topwindow WM_DELETE_WINDOW close_window

#  wm geometry .topwindow 80000+100+100

#  Create_Menubar  .topwindow menubar 

  set height 20

  # build widget .pb1
  button .topwindow.pb1   -background {#AEAEB2B2C3C3} -font {Helvetica 10} \
    -foreground {#000000000000}     -text {Start} 

 button .topwindow.exit \
    -background {#AEAEB2B2C3C3}    -font {Helvetica 10} \
    -foreground {#000000000000}    -text {exit} -command {run_command exit} 

  # build widget .dip1
  checkbutton .topwindow.dip1     -background {#AEAEB2B2C3C3} \
    -font {Helvetica 10}     -foreground {#000000000000} \
    -text {dip1}     -variable {dip1}    -command {run_command dip1 $dip1}

  # build widget .dip2
  checkbutton .topwindow.dip2     -background {#AEAEB2B2C3C3} \
    -font {Helvetica 10}     -foreground {#000000000000} \
    -text {dip2}    -variable {dip2}   -command {run_command dip2 $dip2}

  # build widget .dip3
  checkbutton .topwindow.dip3     -background {#AEAEB2B2C3C3} \
    -font {Helvetica 10}     -foreground {#000000000000} \
    -text {dip3}     -variable {dip3}   -command {run_command dip3 $dip3}
  
  # build widget .dip4  
  checkbutton .topwindow.dip4     -background {#AEAEB2B2C3C3} \
    -font {Helvetica 10}     -foreground {#000000000000} \
    -text {dip4}     -variable {dip4}      -command {run_command dip4 $dip4}

  # build widget .dip5
  checkbutton .topwindow.dip5     -background {#AEAEB2B2C3C3} \
    -font {Helvetica 10}     -foreground {#000000000000} \
    -text {dip5}     -variable {dip5}   -command {run_command dip5 $dip5}

  # build widget .dip6
  checkbutton .topwindow.dip6     -background {#AEAEB2B2C3C3} \
    -font {Helvetica 10}     -foreground {#000000000000} \
    -text {dip6}     -variable {dip6}   -command {run_command dip6 $dip6}
 
  # build widget .dip7
  checkbutton .topwindow.dip7     -background {#AEAEB2B2C3C3} \
    -font {Helvetica 10}     -foreground {#000000000000} \
    -text {dip7}     -variable {dip7}     -command {run_command dip7 $dip7}
  
  # build widget .dip8
  checkbutton .topwindow.dip8     -background {#AEAEB2B2C3C3} \
    -font {Helvetica 10}     -foreground {#000000000000} \
    -text {dip8}     -variable {dip8}     -command {run_command dip8 $dip8}

#   label .topwindow.sign -text " \nUsing Tcl with ModelSim \n   "


 # place

  place .topwindow.dip8 -x 0 -relx 0.79 -y 4 -rely 0.61 -width {} -relwidth {} -height $height -relheight {} -anchor w
    
  place .topwindow.dip7 -x 0 -relx 0.79 -y 4 -rely 0.57 -width {} -relwidth {} -height $height -relheight {} -anchor w
  
  place .topwindow.dip6 -x 0 -relx 0.79 -y 0 -rely 0.54 -width {} -relwidth {} -height $height -relheight {} -anchor w
    
  place .topwindow.dip5 -x 0 -relx 0.79 -y 0 -rely 0.5 -width {} -relwidth {} -height $height -relheight {} -anchor w
  
  place .topwindow.dip4 -x 0 -relx 0.79 -y 0 -rely 0.46 -width {} -relwidth {} -height $height -relheight {} -anchor w
    
  place .topwindow.dip3 -x 0 -relx 0.79 -y 0 -rely 0.42 -width {} -relwidth {} -height $height -relheight {} -anchor w
    
  place .topwindow.dip2 -x 0 -relx 0.79 -y 0 -rely 0.38 -width {} -relwidth {} -height $height -relheight {} -anchor w
  
  place .topwindow.dip1 -x 0 -relx 0.79 -y 0 -rely 0.34 -width {} -relwidth {} -height $height -relheight {} -anchor w

    
  place .topwindow.pb1 -x 0 -relx 0.15 -y 0 -rely 0.69 -width {} -relwidth {} -height $height -relheight {} -anchor s
  
  place .topwindow.exit -x 0 -relx 0.45 -y 0 -rely 0.69 -width {} -relwidth {} -height $height -relheight {} -anchor s
  
#  place .topwindow.sign -x 0 -relx 0.65 -y 0 -rely 0.76 -width {} -relwidth {} -height $height -relheight {} -anchor s


   bind .topwindow.pb1    <Button>        { run_command pb1pressed  }
   bind .topwindow.pb1    <ButtonRelease> { run_command pb1released  }
   
# build widget .pb2
# in TCL/Tk '.' is the default root window. In this application .topwindow is used as the root window

####### uncomment the following lines to add Reset Button
  button .topwindow.pb2    -background {#AEAEB2B2C3C3} -font {Helvetica 10} \
    -foreground {#000000000000}    -text {Reset}
  place .topwindow.pb2 -x 0 -relx 0.30 -y 0 -rely 0.69 -width {} -relwidth {} -height $height -relheight {} -anchor s
   
###### uncomment the lines above for Reset button

# bind the commands to be executed on button press and release
# bind syntax -- bind widgetname action { command to be executed }
# bind can also be used for placing with a different syntax but in this application, the place command has been used

####### uncomment the following lines to bind Reset Button

   bind .topwindow.pb2    <Button>        { run_command pb2pressed  }
   bind .topwindow.pb2    <ButtonRelease> { run_command pb2released  }   

####### uncomment the lines above to bind Reset Button

# after adding we should go to 'proc run_command' and add commands for pb2pressed and pb2released  
# This has been added by default
  
# create the sevensegment displays
  create_display .topwindow.display_r

#######uncomment the next two lines for display 2

  create_display .topwindow.display_l
  set twodisplays 1   

if { $twodisplays == 1 } {
  place .topwindow.display_l -x 0 -relx 0.1 -y 0 -rely 0.1 -width {} -relwidth {} -height {} -relheight {} -anchor nw
}

  place .topwindow.display_r -x 0 -relx 0.4 -y 0 -rely 0.1 -width {} -relwidth {} -height {} -relheight {} -anchor nw

####### the variable twodisplays enables the updating of display_l in proc paint_displays

  .topwindow.dip1 select
  .topwindow.dip2 select

#	paint_displays
}

proc Create_Menubar { toplevel menubar } {

	global tk_version
	
	if { $tk_version >= 8.0 } {
		menu $menubar -type menubar
		$toplevel configure -menu $menubar
	} else {
	
		frame $menubar -borderwidth 1 -relief raised
		pack $menubar -side top -fill x -expand true
	}


}

proc Create_Menu { menubar basename text mnemonic } {
	
#	global
}

proc close_window {} {
  global clock_running
  set clock_running 0
  after 100 {
	quit -sim; noview wave        
	destroy .topwindow
  }
}

proc create_display { display_widget } {

# a black canvas with seven different rectangles to form an 8

  canvas $display_widget -bg #000000 -width 90 -height 150
  $display_widget create rectangle  25  10  65  20 -tags segment0
  $display_widget create rectangle  70  25  80  65 -tags segment1 
  $display_widget create rectangle  70  85  80 125 -tags segment2 
  $display_widget create rectangle  25  130  65 140 -tags segment3 
  $display_widget create rectangle  10  85  20 125 -tags segment4 
  $display_widget create rectangle  10  25  20  65 -tags segment5
  $display_widget create rectangle  25  70  65  80 -tags segment6
}

proc update_display { display_widget pattern } {
  global colours
  foreach bit { 0 1 2 3 4 5 6 } {
    $display_widget itemconfigure segment$bit -fill [lindex $colours [string index $pattern $bit]]
  }
}

proc run_command {command {param 0} } {

global tb clock_running
set tb counter_tb	
set sec 100ms

switch $command {
	
	dip1  { force /$tb/UpDown	$param } 
        dip2  { force /$tb/Enable       $param }

	exit  { close_window } 

	pb1pressed {		start_running		}
	pb1released {		force /$tb/Reset	'0'	}

        pb2pressed {		force /$tb/Reset '1' }
        pb2released {		after 100 force /$tb/Reset '0' }

	clock0          { force /$tb/Clock  '0'  }
	clock1          { force /$tb/Clock  '1'  }

	examine_display_l	{ examine /$tb/display_l }
	examine_display_r	{ examine /$tb/display_r }

	run100		{ run $sec }
	default { puts " This option $command not enabled " }

	}
### display_l and pb2_pressed to be made options... 
# commands for dip3 to dip8 can also be added in the above switch
}

proc initialize {} {
	global tb
	set tb counter_tb
	vlib work
	vmap work work
	
	vcom counter.vhd
	vcom sevensegment.vhd
	vcom counter_tb.vhd
	vcom counter_cfg.vhd
	vsim work.counter_cfg
	
	CreateWindow.

      view wave    
      onerror {resume}
      quietly WaveActivateNextPane {} 0
      add wave -noupdate -format Logic /$tb/clock

# to be made an option
      add wave -noupdate -format Logic /$tb/reset

      add wave -noupdate -format Logic /$tb/enable
      add wave -noupdate -format Logic /$tb/updown
      add wave -noupdate -format Literal -radix hexadecimal /$tb/qout

# This will be displayed in the seven segment display if the left segment is added
      add wave -noupdate -format Literal /$tb/display_l

      add wave -noupdate -format Literal /$tb/display_r

      WaveRestoreZoom {0 ns} {5 sec}
      
      force /$tb/UpDown   '1'
      force /$tb/Enable '1'
      force /$tb/Clock  '0'
      force /$tb/Reset  '1'
      run 250 ms
      force /$tb/Reset  '0'
      run 250 ms

}

set clock_running 0
set clk_count 0
set colours {#330000 #cc0000}
set twodisplays 0

initialize

# uncomment this line to start the display with '0'
update_display .topwindow.display_l 0000000

update_display .topwindow.display_r 0000000
#update_display .topwindow.display_r 0111101



