library ieee;
  use ieee.std_logic_1164.all;
  use ieee.numeric_std.all;
          
entity counter is 

  port ( Clock : in STD_LOGIC;
         Reset : in STD_LOGIC;
         UpDown: in STD_LOGIC;
         Enable: in STD_LOGIC;
         Q     : out STD_LOGIC_VECTOR(7 downto 0));


end counter;

architecture counter_arch of counter is 
    
 signal Cnt: unsigned (7 downto 0);

begin

 process(Clock, Reset)

 begin
	if Reset = '1' then
		Cnt <= ( others => '0');
	elsif Rising_edge(Clock) then
		if Enable = '1' then

		if UpDown = '1' then
			Cnt <= Cnt + 1;
		else
			Cnt <= Cnt - 1;
		end if;
		end if;
	end if;
 end process;

 Q <= Std_logic_vector(Cnt);

end;
