library ieee;
  use ieee.std_logic_1164.all;

entity counter_tb is
end counter_tb;


architecture counter_tb of counter_tb is

  component Counter
 
  port ( Clock : in STD_LOGIC;
	 Reset : in STD_LOGIC;
	 UpDown: in STD_LOGIC;
	 Enable: in STD_LOGIC;
	 Q     : out STD_LOGIC_VECTOR(7 downto 0));
  end component;
	 
  component SevenSegment
  port ( Strinput : in	STD_LOGIC_VECTOR(3 downto 0);
	 Segout	  : out	STD_LOGIC_VECTOR(6 downto 0));
  end component; 

  signal Clock	: STD_LOGIC;
  signal Reset	: STD_LOGIC;
  signal UpDown	: STD_LOGIC;
  signal Enable	: STD_LOGIC;
  signal display_r	: STD_LOGIC_VECTOR(6 downto 0); 
  signal display_l	: STD_LOGIC_VECTOR(6 downto 0);
  signal Qout		: STD_LOGIC_VECTOR(7 downto 0);

begin

M1 : Counter port map(Clock => Clock, Reset => Reset, UpDown => UpDown, 
Enable => Enable, Q => Qout);

M2 : SevenSegment port map(Qout(7 downto 4), display_l);

M3 : SevenSegment port map(Qout(3 downto 0), display_r);

end;
