library IEEE;

use IEEE.std_logic_1164.all;
use IEEE.numeric_Std.all;

entity SevenSegment is

   port ( Strinput : in  STD_LOGIC_VECTOR(3 downto 0);
         Segout   : out STD_LOGIC_VECTOR(6 downto 0));

end;

architecture sevenseg_arch of SevenSegment is 

begin

  process(Strinput)
  begin
	case Strinput is
		
		when "0000" => Segout <= "1111110";
		when "0001" => Segout <= "0110000";
		when "0010" => Segout <= "1101101";
		when "0011" => Segout <= "1111001";
		when "0100" => Segout <= "0110011";
		when "0101" => Segout <= "1011011";
		when "0110" => Segout <= "1011111";
		when "0111" => Segout <= "1110000";
		when "1000" => Segout <= "1111111";
		when "1001" => Segout <= "1111011";
		when "1010" => Segout <= "1110111";
		when "1011" => Segout <= "0011111";
		when "1100" => Segout <= "1001110";
		when "1101" => Segout <= "0111101";
		when "1110" => Segout <= "1001111";
		when "1111" => Segout <= "1000111";
		when others => Segout <= "0000001";
	end case;

  end process;	

end;
